VERSION 5.00
Begin VB.Form frmSetup 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Setup Accounts"
   ClientHeight    =   2550
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5940
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2550
   ScaleWidth      =   5940
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Height          =   375
      Left            =   4560
      TabIndex        =   7
      Top             =   1920
      Width           =   1215
   End
   Begin VB.TextBox txtPort 
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Text            =   "21"
      Top             =   1920
      Width           =   1935
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "&Delete"
      Height          =   375
      Left            =   4560
      TabIndex        =   6
      Top             =   1080
      Width           =   1215
   End
   Begin VB.TextBox txtPass 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   2280
      PasswordChar    =   "*"
      TabIndex        =   3
      Top             =   1080
      Width           =   2175
   End
   Begin VB.TextBox txtName 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   1935
   End
   Begin VB.CommandButton Command1 
      Caption         =   "N&ew Account"
      Height          =   360
      Left            =   4545
      TabIndex        =   5
      Top             =   315
      Width           =   1275
   End
   Begin VB.TextBox txtURL 
      Height          =   375
      Left            =   2235
      TabIndex        =   1
      Top             =   315
      Width           =   2175
   End
   Begin VB.ComboBox cboAcount 
      Height          =   315
      Left            =   105
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   330
      Width           =   1980
   End
   Begin VB.Label Label5 
      Caption         =   "Port:"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   1680
      Width           =   1935
   End
   Begin VB.Label Label4 
      Caption         =   "Password:"
      Height          =   255
      Left            =   2280
      TabIndex        =   11
      Top             =   840
      Width           =   2175
   End
   Begin VB.Label Label3 
      Caption         =   "User Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   840
      Width           =   2055
   End
   Begin VB.Label Label2 
      Caption         =   "Domain Or IP Address:"
      Height          =   330
      Left            =   2235
      TabIndex        =   9
      Top             =   120
      Width           =   1965
   End
   Begin VB.Label Label1 
      Caption         =   "Account:"
      Height          =   480
      Left            =   105
      TabIndex        =   8
      Top             =   120
      Width           =   1920
   End
End
Attribute VB_Name = "frmSetup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit




Private Function OpenAccount()
  On Error Resume Next
  Dim s As Integer, l As String, ua, X As Integer
  cboAcount.Clear
  X = -1
  s = FreeFile()
  Open App.Path & "\ftp.dat" For Input As #s
    Do While Not EOF(s)
      X = X + 1
        Input #1, l
        ua = Split(l, "|")
        
        Account(X).acntname = ua(0)
        Account(X).addy = ua(1)
        Account(X).ip = ua(2)
        Account(X).name = ua(3)
        Account(X).password = ua(4)
        cboAcount.AddItem Account(X).acntname
     Loop
  Close #s
End Function

Private Sub cboAcount_Click()
  txtURL.Text = Account(cboAcount.ListIndex).addy
  txtPort.Text = Account(cboAcount.ListIndex).ip
  txtName.Text = Account(cboAcount.ListIndex).name
  txtPass.Text = Account(cboAcount.ListIndex).password
End Sub

Private Sub cmdClose_Click()
  SaveAccount
  Unload Me
  frmFTP.OpenAccount
End Sub

Private Sub cmdDelete_Click()
  On Error Resume Next
  
  Account(cboAcount.ListIndex).acntname = ""
  Account(cboAcount.ListIndex).addy = ""
  Account(cboAcount.ListIndex).ip = ""
  Account(cboAcount.ListIndex).name = ""
  Account(cboAcount.ListIndex).password = ""
  cboAcount.RemoveItem cboAcount.ListIndex
  If cboAcount.ListCount > 1 Then
    cboAcount.ListIndex = 0
  Else
    txtURL.Text = ""
    txtName.Text = ""
    txtPass.Text = ""
  End If
  SaveAccount
End Sub

Private Sub Command1_Click()
  Dim str As String
  str = InputBox("Please enter the name of this ftp site.", "New FTP")
  If str = "" Then Exit Sub
  Account(cboAcount.ListCount).acntname = str
  cboAcount.AddItem Account(cboAcount.ListCount).acntname
  cboAcount.ListIndex = cboAcount.ListCount - 1
  Account(cboAcount.ListIndex).ip = 21
  txtURL.SetFocus
End Sub

Private Sub Form_Load()
  OpenAccount
  Me.Move frmMain.Left + ((frmMain.Width - Me.Width) \ 2), frmMain.Top + ((frmMain.Height - Me.Height) \ 2)
End Sub

Private Sub txtName_Change()
  On Error Resume Next
  Account(cboAcount.ListIndex).name = txtName.Text
End Sub

Private Sub txtPass_Change()
  On Error Resume Next
  Account(cboAcount.ListIndex).password = txtPass.Text
End Sub

Private Sub txtPort_Change()
  On Error Resume Next
  Account(cboAcount.ListIndex).ip = txtPort.Text
End Sub

Private Sub txtURL_Change()
  On Error Resume Next
  Account(cboAcount.ListIndex).addy = txtURL.Text
End Sub

Private Function SaveAccount()
  On Error Resume Next
  Dim X As Integer, l As Integer
  l = FreeFile()
  Open App.Path & "\ftp.dat" For Output As #l
  For X = 0 To 1000
    If Account(X).acntname = "" Then
      Close #l
      Exit Function
    End If
    Print #l, Account(X).acntname & "|" & Account(X).addy & "|" & Account(X).ip & "|" & Account(X).name & "|" & Account(X).password
  Next X
  Close #l
End Function
