Attribute VB_Name = "modApp"
Option Explicit
'+------------------------------------------------------------+
'| Application module. Contains functions specificly involved |
'| with file creation and editing, opening, etc.              |
'| Coder: Ackbar                                              |
'| You may use this as long as you leave this section in.     |
'+------------------------------------------------------------+

Public docCnt As Integer 'This stores the number of new documents.
Public docCnt2 As Long    'This stores the real document count :)
Public HighLight As Boolean 'This stores whether or not to highlight the
                            'selected line :)
Public Question As Boolean
Public frm(20) As frmDoc
Public WhiteSpaced As Boolean
                            
Public Function doNew()
  Dim bl As String
  If docCnt >= 20 Then
    MsgBox "You already have the maximum number of documents open.", vbOKOnly + vbInformation, "Document Count"
    Exit Function
  End If
  docCnt = docCnt + 1
  docCnt2 = docCnt2 + 1

  Set frm(docCnt) = New frmDoc
  frm(docCnt).TabNum = docCnt2
  frm(docCnt).Tag = docCnt
  frm(docCnt).Caption = "New Document " & docCnt2
  frm(docCnt).Show
  frmMain.tb.Tabs.Add docCnt
  frmMain.tb.Tabs(docCnt).Tag = docCnt2
  frmMain.tb.Tabs(docCnt).Caption = frm(docCnt).Caption
  frmMain.tb.Tabs(docCnt).Selected = True
End Function

Public Function doSave(frmNum As Integer)
  On Error Resume Next
  Dim frmNum2 As Integer
  frmNum2 = frmNum
  If Left(frmMain.ActiveForm.Caption, 12) = "New Document" Then
    doSaveAs frmNum2
  Else
    frm(frmNum).rt.SaveFile frmMain.ActiveForm.Caption, True
    frm(frmNum).Changed = False
  End If
End Function


Public Function doSaveAs(frmNum As Integer)
  On Error Resume Next
  Dim msg As VbMsgBoxResult
  frmMain.cd.CancelError = True
  frmMain.cd.Filename = ""
  frmMain.cd.DialogTitle = "Save document... " & frm(frmNum).Caption
  frmMain.cd.Filter = "All Files|*.*|Text Files|*.txt|Html Files|*.html;*.htm|Style Sheets|*.css|Java Scripting|*.js|C Files|*.c|C++ Files|*.cpp|C/C++ Header Files|*.h|Perl Files|*.pl|CGI/Perl Files|*.cgi|XML Files|*.xml|Pascal Files|*.pas|Basic Module Files|*.bas|Basic Form Files|*.frm|Basic Project Files|*.vbp|Basic Class Modules|*.cls"
  frmMain.cd.ShowSave
  If frmMain.cd.Filename = "" Then Exit Function
  If FileExists(frmMain.cd.Filename) = True Then
     msg = MsgBox(frmMain.cd.Filename & " Already exists." & Chr(10) & "Do you want to replace it?", vbYesNo + vbQuestion, "Overwrite")
    If msg = vbYes Then
      'continue
    ElseIf msg = vbNo Then
      doSaveAs frmNum
    End If
  End If
  frm(frmNum).rt.SaveFile frmMain.cd.Filename, True
  frm(frmNum).Caption = frmMain.cd.Filename
  frm(frmNum).rt.language = SetSyntax(frmMain.cd.Filename)
  frm(frmNum).Changed = False
End Function

Public Sub Registerlang(ByVal rt As CodeMaxCtl.ICodeMax)
  Dim lang As CodeMaxCtl.language
  Set lang = New CodeMaxCtl.language
  Dim e As CodeMaxCtl.globals
  Set e = New CodeMaxCtl.globals
  lang = e.GetLanguageDef("java")
  Call e.RegisterLanguage("css", lang)
  lang.CaseSensitive = True
  Dim str As String
  str = ""
  str = "abs" + Chr(10) + "if" + Chr(10) + "accept" + Chr(10) + "accept" + Chr(10) + "alarm" + Chr(10) + "atan2" + Chr(10) + "atan2" + Chr(10) + "bind" + Chr(10) + "bind" + Chr(10) + "binmode" + Chr(10)
  str = str + "binmode" + Chr(10) + "bless" + Chr(10) + "bless" + Chr(10) + "caller" + Chr(10) + "chdir" + Chr(10) + "chmod" + Chr(10) + "chmod" + Chr(10) + "chomp" + Chr(10) + "chop" + Chr(10) + "chown" + Chr(10)
  str = str + "chr" + Chr(10) + "chroot" + Chr(10) + "close" + Chr(10) + "closedir" + Chr(10) + "connect" + Chr(10) + "connect" + Chr(10) + "cos" + Chr(10) + "crypt" + Chr(10) + "crypt" + Chr(10) + "dbmclose" + Chr(10)
  str = str + "dbmopen" + Chr(10) + "dbmopen" + Chr(10) + "dbmopen" + Chr(10) + "dbmopen" + Chr(10) + "dbmopen" + Chr(10) + "dbmopen" + Chr(10) + "dbmopen" + Chr(10) + "defined" + Chr(10) + "delete" + Chr(10) + "die " + Chr(10)
  str = str + "do" + Chr(10) + "dump" + Chr(10) + "each" + Chr(10) + "eof" + Chr(10) + "eval" + Chr(10) + "exec" + Chr(10) + "exists" + Chr(10) + "exit" + Chr(10) + "exp" + Chr(10) + "fcntl" + Chr(10)
  str = str + "fcntl" + Chr(10) + "fcntl" + Chr(10) + "fileno" + Chr(10) + "flock" + Chr(10) + "flock" + Chr(10) + "fork" + Chr(10) + "format" + Chr(10) + "formline" + Chr(10) + "formline" + Chr(10) + "getc" + Chr(10)
  str = str + "getlogin" + Chr(10) + "getpeername" + Chr(10) + "getpgrp" + Chr(10) + "getppid" + Chr(10) + "getpriority" + Chr(10) + "getpriority" + Chr(10) + "getsockname" + Chr(10) + "getsockopt" + Chr(10) + "getsockopt" + Chr(10) + "getsockopt" + Chr(10)
  str = str + "glob" + Chr(10) + "gmtime" + Chr(10) + "goto" + Chr(10) + "goto" + Chr(10) + "goto" + Chr(10) + "grep" + Chr(10) + "grep" + Chr(10) + "hex" + Chr(10) + "import" + Chr(10) + "index" + Chr(10)
  str = str + "index" + Chr(10) + "index" + Chr(10) + "int" + Chr(10) + "ioctl" + Chr(10) + "ioctl" + Chr(10) + "ioctl" + Chr(10) + "join" + Chr(10) + "join" + Chr(10) + "keys" + Chr(10) + "kill" + Chr(10)
  str = str + "last" + Chr(10) + "lc" + Chr(10) + "lcfirst" + Chr(10) + "length" + Chr(10) + "link" + Chr(10) + "link" + Chr(10) + "listen" + Chr(10) + "listen" + Chr(10) + "local" + Chr(10) + "localtime" + Chr(10)
  str = str + "log" + Chr(10) + "lstat" + Chr(10) + "map" + Chr(10) + "map" + Chr(10) + "mkdir" + Chr(10) + "mkdir" + Chr(10) + "msgctl" + Chr(10) + "msgctl" + Chr(10) + "msgctl" + Chr(10) + "msgget" + Chr(10)
  str = str + "msgget" + Chr(10) + "msgrcv" + Chr(10) + "msgrcv" + Chr(10) + "msgrcv" + Chr(10) + "msgrcv" + Chr(10) + "msgrcv" + Chr(10) + "msgsnd" + Chr(10) + "msgsnd" + Chr(10) + "msgsnd" + Chr(10) + "my" + Chr(10)
  str = str + "next" + Chr(10) + "no" + Chr(10) + "oct" + Chr(10) + "open" + Chr(10) + "open" + Chr(10) + "opendir" + Chr(10) + "opendir" + Chr(10) + "ord" + Chr(10) + "pack" + Chr(10) + "pack" + Chr(10)
  str = str + "package" + Chr(10) + "pipe" + Chr(10) + "pipe" + Chr(10) + "pop" + Chr(10) + "pos" + Chr(10) + "print" + Chr(10) + "printf" + Chr(10) + "push" + Chr(10) + "push" + Chr(10) + "quotemeta" + Chr(10)
  str = str + "rand" + Chr(10) + "read" + Chr(10) + "read" + Chr(10) + "read" + Chr(10) + "read" + Chr(10) + "readdir" + Chr(10) + "readlink" + Chr(10) + "recv" + Chr(10) + "recv" + Chr(10) + "recv" + Chr(10)
  str = str + "recv" + Chr(10) + "redo" + Chr(10) + "ref" + Chr(10) + "rename" + Chr(10) + "rename" + Chr(10) + "require" + Chr(10) + "reset" + Chr(10) + "return" + Chr(10) + "return" + Chr(10) + "return" + Chr(10)
  str = str + "reverse" + Chr(10) + "rewinddir" + Chr(10) + "remdir" + Chr(10) + "scalar" + Chr(10) + "seek" + Chr(10) + "seek" + Chr(10) + "seek" + Chr(10) + "seekdir" + Chr(10) + "seekdir" + Chr(10) + "select" + Chr(10)
  str = str + "semctl" + Chr(10) + "semctl" + Chr(10) + "semctl" + Chr(10) + "semctl" + Chr(10) + "semget" + Chr(10) + "semget" + Chr(10) + "semget" + Chr(10) + "semget" + Chr(10) + "semop" + Chr(10) + "semop" + Chr(10)
  str = str + "send" + Chr(10) + "send" + Chr(10) + "send" + Chr(10) + "send" + Chr(10) + "setpgrp" + Chr(10) + "setpgrp" + Chr(10) + "setpriority" + Chr(10) + "setpriority" + Chr(10) + "setpriority" + Chr(10) + "setsockopt" + Chr(10)
  str = str + "setsockopt" + Chr(10) + "setsockopt" + Chr(10) + "setsockopt" + Chr(10) + "shift" + Chr(10) + "shmctl" + Chr(10) + "shmctl" + Chr(10) + "shmctl" + Chr(10) + "shmget" + Chr(10) + "shmget" + Chr(10) + "shmget" + Chr(10)
  str = str + "shmread" + Chr(10) + "shmread" + Chr(10) + "shmread" + Chr(10) + "shmread" + Chr(10) + "shmwrite" + Chr(10) + "shmwrite" + Chr(10) + "shmwrite" + Chr(10) + "shmwrite" + Chr(10) + "shutdown" + Chr(10) + "shutdown" + Chr(10)
  str = str + "sin" + Chr(10) + "sleep" + Chr(10) + "socket" + Chr(10) + "socket" + Chr(10) + "socket" + Chr(10) + "socket" + Chr(10) + "socketpair" + Chr(10) + "socketpair" + Chr(10) + "socketpair" + Chr(10) + "socketpair" + Chr(10)
  str = str + "socketpair" + Chr(10) + "sort" + Chr(10) + "splice" + Chr(10) + "splice" + Chr(10) + "splice" + Chr(10) + "splice" + Chr(10) + "split" + Chr(10) + "split" + Chr(10) + "split" + Chr(10) + "sprintf" + Chr(10)
  str = str + "sprintf" + Chr(10) + "sqrt" + Chr(10) + "srand" + Chr(10) + "stat" + Chr(10) + "study" + Chr(10) + "substr" + Chr(10) + "substr" + Chr(10) + "substr" + Chr(10) + "symlink" + Chr(10) + "symlink" + Chr(10)
  str = str + "syscall" + Chr(10) + "sysopen" + Chr(10) + "sysopen" + Chr(10) + "sysopen" + Chr(10) + "sysread" + Chr(10) + "sysread" + Chr(10) + "sysread" + Chr(10) + "sysread" + Chr(10) + "sysseek" + Chr(10) + "sysseek" + Chr(10)
  str = str + "sysseek" + Chr(10) + "system" + Chr(10) + "syswrite" + Chr(10) + "syswrite" + Chr(10) + "syswrite" + Chr(10) + "syswrite" + Chr(10) + "tell" + Chr(10) + "telldir" + Chr(10) + "tie" + Chr(10) + "tie" + Chr(10)
  str = str + "tie" + Chr(10) + "tied" + Chr(10) + "time" + Chr(10) + "times" + Chr(10) + "truncate" + Chr(10) + "truncate" + Chr(10) + "uc" + Chr(10) + "ucfirst" + Chr(10) + "umask" + Chr(10) + "undef" + Chr(10)
  str = str + "unlink" + Chr(10) + "unpack" + Chr(10) + "unpack" + Chr(10) + "unshift" + Chr(10) + "unshift" + Chr(10) + "utime" + Chr(10) + "values" + Chr(10) + "vec" + Chr(10) + "vec" + Chr(10) + "vec" + Chr(10)
  str = str + "wait" + Chr(10) + "waitpid" + Chr(10) + "waitpid" + Chr(10) + "wantarray" + Chr(10) + "warn" + Chr(10) + "write" + Chr(10) + "$" + Chr(10)
  lang.Keywords = str
  lang.style = cmLangStyleProcedural
  str = "=" + Chr(10) + ">" + Chr(10) + "<" + Chr(10) + "/"
  lang.Operators = str
  lang.SingleLineComments = "# "
  lang.ScopeKeywords1 = "{"
  lang.ScopeKeywords2 = "}"
  lang.StringDelims = Chr$(34) + Chr$(10) + "'"
  lang.EscapeChar = "\"
  lang.TerminatorChar = ";"
  Dim globals As CodeMaxCtl.globals
  Set globals = New CodeMaxCtl.globals
  Call globals.RegisterLanguage("Perl", lang)

End Sub

Public Function doOpen(doc As String, title As String)
  If docCnt >= 20 Then
    MsgBox "You already have the maximum number of documents open.", vbOKOnly + vbInformation, "Document Count"
    Exit Function
  End If
  docCnt = docCnt + 1
  docCnt2 = docCnt2 + 1
  Set frm(docCnt) = New frmDoc
  frm(docCnt).TabNum = docCnt2
  frm(docCnt).Tag = docCnt
  frm(docCnt).rt.OpenFile doc
  frm(docCnt).rt.language = SetSyntax(doc)
  frm(docCnt).Caption = doc
  frm(docCnt).Show
  frmMain.tb.Tabs.Add docCnt
  frmMain.tb.Tabs(docCnt).Tag = docCnt2
  frmMain.tb.Tabs(docCnt).Caption = title
  frmMain.tb.Tabs(docCnt).Selected = True
End Function


Public Function SetSyntax(fil As String) As String
  Select Case LCase(Right(fil, 2))
    Case ".c"
      SetSyntax = "c/c++"
    Case ".h"
      SetSyntax = "c/c++"
  End Select
  
  Select Case LCase(Right(fil, 3))
    Case ".pl"
      SetSyntax = "perl"
    Case ".js"
      SetSyntax = "java"
    End Select
    
  Select Case LCase(Right(fil, 4))
    Case ".txt"
      SetSyntax = ""
    Case ".sql"
      SetSyntax = "sql"
    Case ".cls"
      SetSyntax = "basic"
    Case ".htm"
      SetSyntax = "html"
    Case ".cpp"
      SetSyntax = "c/c++"
    Case ".cgi"
      SetSyntax = "perl"
    Case ".xml"
      SetSyntax = "xml"
    Case ".pas"
      SetSyntax = "pascal"
    Case ".bas"
      SetSyntax = "basic"
    Case ".frm"
      SetSyntax = "basic"
    Case ".vbp"
      SetSyntax = "basic"
    Case ".css"
      SetSyntax = "css"
  End Select
  
  If LCase(Right(fil, 5)) = ".html" Then
    SetSyntax = "html"
  End If
  If LCase(Right(fil, 5)) = ".java" Then
    SetSyntax = "java"
  End If
End Function

Public Function FileExists(FullFileName As String) As Boolean
    On Error GoTo MakeF
        'If file does Not exist, there will be an Error
        Open FullFileName For Input As #1
        Close #1
        'no error, file exists
        FileExists = True
    Exit Function
MakeF:
        'error, file does Not exist
        FileExists = False
    Exit Function
End Function


Public Function doSave2(Data As String)
  On Error Resume Next

    frm(frmMain.ActiveForm.Tag).rt.SaveFile Data, True
    frm(frmMain.ActiveForm.Tag).Changed = False
    frm(frmMain.ActiveForm.Tag).rt.language = SetSyntax(Data)
End Function

Public Function DoFTPSave()

End Function
