
void	unlink_social	args( ( SOCIALTYPE *social ) );
char * sclass		args( ( sh_int clss, CHAR_DATA *victm) );

char * convert_rank		args( ( sh_int rank ) );

#if defined(KEY)
#undef KEY
#endif

#define KEY( literal, field, value )					\
				if ( !str_cmp( word, literal ) )	\
				{					\
				    field  = value;			\
				    fMatch = TRUE;			\
				    break;				\
				}

void do_makeimm(CHAR_DATA *ch, char *argument){
   int lvl;
   char arg1[MAX_STRING_LENGTH];
   char arg2[MAX_STRING_LENGTH];
   char buf[MAX_INPUT_LENGTH];
   CHAR_DATA *victim;
   
   argument = one_argument(argument, arg1);
   argument = one_argument(argument, arg2);
   
   if ((arg1[0] = '\0') || (arg2[0] == '\0')){
   	send_to_char("Syntax: Makeimm <name> <level>\n\r", ch);
   	return;
   }
   
   if ((victim = get_char_world(ch, arg1)) == NULL){
   	sprintf(buf, "%s does not appear to be online.\n\r", arg1);
   	send_to_char(buf, ch);
   	return;
   }
   lvl = 0;
   lvl = atoi(arg2);
   
   if (lvl > 12 || lvl < 7){
   	send_to_char("Specificed level outside of level range.\n\r", ch);
   	return;
   }
   
   if (victim->level >= ch->level){
   	send_to_char("They might not like that.\n\r", ch);
   	return;
   }
   
   if (lvl <= victim->level){
   	send_to_char("What would be the point of that?\n\r", ch);
   	return;
   }
      
   victim->level = lvl;
   victim->trust = lvl;
   sprintf(buf, "%s has bestowed upon you the honor of being an immortal.\n\r", ch->name);
   send_to_char(buf, victim);
   sprintf(buf, "You have bestowed upon %s the honor of being an immortal.\n\r", victim->name);
   send_to_char(buf, ch);
   
   
}
   

void do_doublexp( CHAR_DATA *ch, char *argument){
  /*Double Exp*/
  char buf[MAX_STRING_LENGTH];
  if (doublexp != 1){
    doublexp = 1;
    triplexp = 0;
    sprintf(buf, "#r%s #7has declared double experience.", ch->name);
    do_info( ch, buf );   
  }
  else {
    sprintf(buf, "#r%s #7has removed double experience.", ch->name);
    do_info( ch, buf );   
    doublexp = 0;
  }

}

void do_triplexp( CHAR_DATA *ch, char *argument){
  /*Double Exp*/
  char buf[MAX_STRING_LENGTH];
  if (triplexp != 1){
    triplexp = 1;
    doublexp = 0;
    sprintf(buf, "#r%s #7has declared triple experience.", ch->name);
    do_info( ch, buf );   
  }
  else {
    sprintf(buf, "#r%s #7has removed triple experience.", ch->name);
    do_info( ch, buf );   
    triplexp = 0;
  }

}
    
void echo_to_all( sh_int AT_COLOR, char *argument, sh_int tar )
{
    DESCRIPTOR_DATA *d;

    if ( !argument || argument[0] == '\0' )
	return;

    for ( d = descriptor_list; d; d = d->next )
    {
        /* Added showing echoes to players who are editing, so they won't
           miss out on important info like upcoming reboots. --Narn */ 
	if ( d->connected == CON_PLAYING || d->connected == CON_EDITING )
	{
	    /* This one is kinda useless except for switched.. */
	    if ( tar == ECHOTAR_PC && IS_NPC(d->character) )
	      continue;
	    else if ( tar == ECHOTAR_IMM && !IS_IMMORTAL(d->character) )
	      continue;
	    send_to_char( argument, d->character );
	    send_to_char( "\n\r",   d->character );
	}
    }
    return;
}    

   
void fread_social( FILE *fp )
{
    char buf[MAX_STRING_LENGTH];
    char *word;
    bool fMatch;
    SOCIALTYPE *social;

    CREATE( social, SOCIALTYPE, 1 );

    for ( ;; )
    {
	word   = feof( fp ) ? "End" : fread_word( fp );
	fMatch = FALSE;

	switch ( UPPER(word[0]) )
	{
	case '*':
	    fMatch = TRUE;
	    fread_to_eol( fp );
	    break;

	case 'C':
	    KEY( "CharNoArg",	social->char_no_arg,	fread_string(fp) );
	    KEY( "CharFound",	social->char_found,	fread_string(fp) );
	    KEY( "CharAuto",	social->char_auto,	fread_string(fp) );
	    break;

	case 'E':
	    if ( !str_cmp( word, "End" ) )
	    {
		if ( !social->name )
		{
		    
		    free_social( social );
		    return;
		}
		if ( !social->char_no_arg )
		{
		    
		    free_social( social );
		    return;
		}
		add_social( social );
		return;
	    }
	    break;

	case 'N':
	    KEY( "Name",	social->name,		fread_string(fp) );
	    break;

	case 'O':
	    KEY( "OthersNoArg",	social->others_no_arg,	fread_string(fp) );
	    KEY( "OthersFound",	social->others_found,	fread_string(fp) );
	    KEY( "OthersAuto",	social->others_auto,	fread_string(fp) );
	    break;

	case 'V':
	    KEY( "VictFound",	social->vict_found,	fread_string(fp) );
	    break;
	}
	
	if ( !fMatch )
	{
            sprintf( buf, "Fread_social: no match: %s", word );
	    
	}
    }
}

void load_socials()
{
    FILE *fp;

    if ( ( fp = fopen( SOCIAL_FILE, "r" ) ) != NULL )
    {
	//top_sn = 0;
	for ( ;; )
	{
	    char letter;
	    char *word;

	    letter = fread_letter( fp );
	    if ( letter == '*' )
	    {
		fread_to_eol( fp );
		continue;
	    }

	    if ( letter != '#' )
	    {
                
		break;
	    }

	    word = fread_word( fp );
            if ( !str_cmp( word, "SOCIAL"      ) )
	    {
                fread_social( fp );
	    	continue;
	    }
	    else
	    if ( !str_cmp( word, "END"	) )
	        break;
	    else
	    {
                
		continue;
	    }
	}
	fclose( fp );
    }
    else
    {
	
 	exit(0);
    }
}

   
void do_sedit( CHAR_DATA *ch, char *argument )
{
    SOCIALTYPE *social;
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];

    smash_tilde( argument );
    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );


    if ( arg1[0] == '\0' )
    {
	send_to_char( "Syntax: sedit <social> [field]\n\r", ch );
	send_to_char( "Syntax: sedit <social> create\n\r", ch );
	if ( get_trust(ch) >= 7 )
	    send_to_char( "Syntax: sedit <social> delete\n\r", ch );
	if ( get_trust(ch) >= 7 )
	    send_to_char( "Syntax: sedit <save>\n\r", ch );
	send_to_char( "\n\rField being one of:\n\r", ch );
	send_to_char( "  cnoarg onoarg cfound ofound vfound cauto oauto\n\r", ch );
	return;
    }

    if ( get_trust(ch) >= 7 && !str_cmp( arg1, "save" ) )
    {
	save_socials();
	send_to_char( "Saved.\n\r", ch );
	return;
    }

    social = find_social( arg1 );

    if ( !str_cmp( arg2, "create" ) )
    {
	if ( social )
	{
	    send_to_char( "That social already exists!\n\r", ch );
	    return;
	}
	CREATE( social, SOCIALTYPE, 1 );
	social->name = str_dup( arg1 );
	sprintf( arg2, "You %s.", arg1 );
	social->char_no_arg = str_dup( arg2 );
	add_social( social );
	send_to_char( "Social added.\n\r", ch );
	return;
    }

    if ( !social )
    {
	send_to_char( "Social not found.\n\r", ch );
	return;
    }

    if ( arg2[0] == '\0' || !str_cmp( arg2, "show" ) )
    {
	ch_printf( ch, "Social: %s\n\r\n\rCNoArg: %s\n\r",
	    social->name,	social->char_no_arg );
	ch_printf( ch, "ONoArg: %s\n\rCFound: %s\n\rOFound: %s\n\r",
	    social->others_no_arg	? social->others_no_arg	: "(not set)",
	    social->char_found		? social->char_found	: "(not set)",
	    social->others_found	? social->others_found	: "(not set)" );
	ch_printf( ch, "VFound: %s\n\rCAuto : %s\n\rOAuto : %s\n\r",
	    social->vict_found	? social->vict_found	: "(not set)",
	    social->char_auto	? social->char_auto	: "(not set)",
	    social->others_auto	? social->others_auto	: "(not set)" );
	return;
    }

    if ( get_trust(ch) > 7 && !str_cmp( arg2, "delete" ) )
    {
    	//send_to_char("Temporarely disabled because it crashes the mud and I gotta look at it.\n\r", ch);
    	//return;
	unlink_social( social );
	free_social( social );
	send_to_char( "Deleted.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg2, "cnoarg" ) )
    {
	if ( argument[0] == '\0' || !str_cmp( argument, "clear" ) )
	{
	    send_to_char( "You cannot clear this field.  It must have a message.\n\r", ch );
	    return;
	}
	if ( social->char_no_arg )
	    
	social->char_no_arg = str_dup( argument );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg2, "onoarg" ) )
    {
	if ( social->others_no_arg )
	    sprintf(social->others_no_arg, "\r");
	if ( argument[0] != '\0' && str_cmp( argument, "clear" ) )
	    social->others_no_arg = str_dup( argument );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg2, "cfound" ) )
    {
	if ( social->char_found )
	      sprintf(social->char_found, "\r");
	if ( argument[0] != '\0' && str_cmp( argument, "clear" ) )
	    social->char_found = str_dup( argument );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg2, "ofound" ) )
    {
	if ( social->others_found )
	    sprintf(social->others_found, "\r");
	if ( argument[0] != '\0' && str_cmp( argument, "clear" ) )
	    social->others_found = str_dup( argument );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg2, "vfound" ) )
    {
	if ( social->vict_found )
	   sprintf(social->vict_found, "\r"); 
	if ( argument[0] != '\0' && str_cmp( argument, "clear" ) )
	    social->vict_found = str_dup( argument );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg2, "cauto" ) )
    {
	if ( social->char_auto )
	    sprintf(social->char_auto, "\r");
	if ( argument[0] != '\0' && str_cmp( argument, "clear" ) )
	    social->char_auto = str_dup( argument );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg2, "oauto" ) )
    {
	if ( social->others_auto )
	  sprintf(social->others_auto, "\r");  
	if ( argument[0] != '\0' && str_cmp( argument, "clear" ) )
	    social->others_auto = str_dup( argument );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    if ( get_trust(ch) > 7 && !str_cmp( arg2, "name" ) )
    {
	bool relocate;

	one_argument( argument, arg1 );
	if ( arg1[0] == '\0' )
	{
	    send_to_char( "Cannot clear name field!\n\r", ch );
	    return;
	}
	if ( arg1[0] != social->name[0] )
	{
	    unlink_social( social );
	    relocate = TRUE;
	}
	else
	    relocate = FALSE;
	if ( social->name )
	    
	social->name = str_dup( arg1 );
	if ( relocate )
	    add_social( social );
	send_to_char( "Done.\n\r", ch );
	return;
    }

    /* display usage message */
    do_sedit( ch, "" );
}


void add_social( SOCIALTYPE *social )
{
    int hash, x;
    SOCIALTYPE *tmp, *prev;

    if ( !social )
    {
	
	return;
    }

    if ( !social->name )
    {
	
	return;
    }

    if ( !social->char_no_arg )
    {
	
	return;
    }

    /* make sure the name is all lowercase */
    for ( x = 0; social->name[x] != '\0'; x++ )
	social->name[x] = LOWER(social->name[x]);

    if ( social->name[0] < 'a' || social->name[0] > 'z' )
	hash = 0;
    else
	hash = (social->name[0] - 'a') + 1;

    if ( (prev = tmp = social_index[hash]) == NULL )
    {
	social->next = social_index[hash];
	social_index[hash] = social;
	return;
    }

    for ( ; tmp; tmp = tmp->next )
    {
	if ( (x=strcmp(social->name, tmp->name)) == 0 )
	{
	    
	    free_social( social );
	    return;
	}
	else
	if ( x < 0 )
	{
	    if ( tmp == social_index[hash] )
	    {
		social->next = social_index[hash];
		social_index[hash] = social;
		return;
	    }
	    prev->next = social;
	    social->next = tmp;
	    return;
	}
	prev = tmp;
    }

    /* add to end */
    prev->next = social;
    social->next = NULL;
    return;
}   

void free_social( SOCIALTYPE *social )
{
    if ( social->name )
      sprintf(social->name, "\r");
    if ( social->char_no_arg )
      sprintf(social->char_no_arg, "\r");
    if ( social->others_no_arg )
      sprintf( social->others_no_arg, "\r" );
    if ( social->char_found )
      sprintf( social->char_found , "\r");
    if ( social->others_found )
      sprintf( social->others_found , "\r");
    if ( social->vict_found )
      sprintf( social->vict_found , "\r");
    if ( social->char_auto )
      sprintf( social->char_auto, "\r");
    if ( social->others_auto )
      sprintf( social->others_auto, "\r" );
    
}

/*
 * Remove a social from it's hash index				-Thoric
 */
void unlink_social( SOCIALTYPE *social )
{
    SOCIALTYPE *tmp, *tmp_next;
    int hash;

    if ( !social )
    {
	
	return;
    }

    if ( social->name[0] < 'a' || social->name[0] > 'z' )
	hash = 0;
    else
	hash = (social->name[0] - 'a') + 1;

    if ( social == (tmp=social_index[hash]) )
    {
	social_index[hash] = tmp->next;
	return;
    }
    for ( ; tmp; tmp = tmp_next )
    {
	tmp_next = tmp->next;
	if ( social == tmp_next )
	{
	    tmp->next = tmp_next->next;
	    return;
	}
    }
}
SOCIALTYPE *find_social( char *command )
{
    SOCIALTYPE *social;
    int hash;

    if ( command[0] < 'a' || command[0] > 'z' )
	hash = 0;
    else
	hash = (command[0] - 'a') + 1;

    for ( social = social_index[hash]; social; social = social->next )
	if ( !str_prefix( command, social->name ) )
	    return social;

    return NULL;
}

void ch_printf(CHAR_DATA *ch, char *fmt, ...)
{
    char buf[MAX_STRING_LENGTH*2];	/* better safe than sorry */
    va_list args;

    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    va_end(args);
	
    send_to_char(buf, ch);
}

void save_socials()
{
    FILE *fpout;
    SOCIALTYPE *social;
    int x;

    if ( (fpout=fopen( SOCIAL_FILE, "w" )) == NULL )
    {
	bug( "Cannot open socials.dat for writting", 0 );
	perror( SOCIAL_FILE );
	return;
    }

    for ( x = 0; x < 27; x++ )
    {
	for ( social = social_index[x]; social; social = social->next )
	{
	    if ( !social->name || social->name[0] == '\0' )
	    {
		bug( "Save_socials: blank social in hash bucket %d", x );
		continue;
	    }
	    fprintf( fpout, "#SOCIAL\n" );
	    fprintf( fpout, "Name        %s~\n",	social->name );
	    if ( social->char_no_arg )
		fprintf( fpout, "CharNoArg   %s~\n",	social->char_no_arg );
	    else
	        bug( "Save_socials: NULL char_no_arg in hash bucket %d", x );
	    if ( social->others_no_arg )
		fprintf( fpout, "OthersNoArg %s~\n",	social->others_no_arg );
	    if ( social->char_found )
		fprintf( fpout, "CharFound   %s~\n",	social->char_found );
	    if ( social->others_found )
		fprintf( fpout, "OthersFound %s~\n",	social->others_found );
	    if ( social->vict_found )
		fprintf( fpout, "VictFound   %s~\n",	social->vict_found );
	    if ( social->char_auto )
		fprintf( fpout, "CharAuto    %s~\n",	social->char_auto );
	    if ( social->others_auto )
		fprintf( fpout, "OthersAuto  %s~\n",	social->others_auto );
	    fprintf( fpout, "End\n\n" );
	}
    }
    fprintf( fpout, "#END\n" );
    fclose( fpout );
}




void do_selfclass( CHAR_DATA *ch, char *argument )
{
 
    char      arg2 [MAX_INPUT_LENGTH];
    argument = one_argument( argument, arg2 );
        
    if ( IS_NPC(ch) ) return;
    
    if (  arg2[0] == '\0' )
    {
	send_to_char( "Syntax: selfclass <class>.\n\r", ch );
	send_to_char("      Classes:\n\r", ch );
    send_to_char("Demon, ", ch);
    send_to_char("Demon Lord , ", ch);
    send_to_char("Purple Mage, Blue Mage, Yellow Mage, Green Mage, Red Mage, ", ch);
    send_to_char("Werewolf, ", ch);
    send_to_char("Vampire, ", ch);
    send_to_char("Highlander, ", ch);
    //stc("Dragon.",ch);
	return;
    }
    

    if ((ch->class != 0) && str_cmp(arg2, "none") ) 
    {
	stc("You have already classed yourself.\n\r", ch);
	return;
    }


    else if ( !str_cmp( arg2, "demon"      ) ) 
    { 
    ch->class = 1;
   if (!IS_IMMORTAL(ch) )
       ch->level = 3;
    SET_BIT( ch->special, SPC_CHAMPION );
    ch->lord=str_dup(ch->name);
    send_to_char("You are now a demon!\n\r", ch);
    }
/*
    else if ( !str_cmp( arg2, "dragon" 	) )
    {
        ch->class = CLASS_DRAGON;
        ch->pcdata->disc_a[DRAGON_AGE] = 1;
        ch->pcdata->disc_a[DRAGON_COLOR] = number_range(1,9);
        stc("You are now a dragon.\n\r",ch);
    }
*/
    else if ( !str_cmp( arg2, "demon lord"      ) ) 
    {
    ch->class = 1;
  if (!IS_IMMORTAL(ch) )
    ch->level = 3;
    SET_BIT( ch->special, SPC_DEMON_LORD );
    ch->lord=str_dup(ch->name);
    send_to_char("You are now a Demon Lord!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "purple mage"     ) )
    {
    ch->class = 2;
    if ( ch->trust > 6 )
    {
    ch->trust = ch->trust;
    ch->level = ch->level;
    }
    else
    {
    ch->trust = 6;
    ch->level = 6;
    }
    ch->pcdata->powers[MPOWER_RUNE0] = 0;
    ch->pcdata->powers[MPOWER_RUNE1] = 2047;
    ch->pcdata->powers[MPOWER_RUNE2] = 1023;
    ch->pcdata->powers[MPOWER_RUNE3] = 15;    
    send_to_char("You are now a purple mage!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "red mage"     ) )
    {
    ch->class = 2;
    if ( ch->trust > 6 )
    {
    ch->trust = ch->trust;
    ch->level = ch->level;
    }
    else
    {
    ch->trust = 6;
    ch->level = 6;
    }
    ch->pcdata->powers[MPOWER_RUNE0] = 1;
    ch->pcdata->powers[MPOWER_RUNE1] = 2047;
    ch->pcdata->powers[MPOWER_RUNE2] = 1023;
    ch->pcdata->powers[MPOWER_RUNE3] = 15;    
    send_to_char("You are now a red mage!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "yellow mage"     ) )
    {
    ch->class = 2;
    if ( ch->trust > 6 )
    {
    ch->trust = ch->trust;
    ch->level = ch->level;
    }
    else
    {
    ch->trust = 6;
    ch->level = 6;
    }
    ch->pcdata->powers[MPOWER_RUNE0] = 4;
    ch->pcdata->powers[MPOWER_RUNE1] = 2047;
    ch->pcdata->powers[MPOWER_RUNE2] = 1023;
    ch->pcdata->powers[MPOWER_RUNE3] = 15;    
    send_to_char("You are now a yellow mage!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "blue mage"     ) )
    {
    ch->class = 2;
    if ( ch->trust > 6 )
    {
    ch->trust = ch->trust;
    ch->level = ch->level;
    }
    else
    {
    ch->trust = 6;
    ch->level = 6;
    }
    ch->pcdata->powers[MPOWER_RUNE0] = 2;
    ch->pcdata->powers[MPOWER_RUNE1] = 2047;
    ch->pcdata->powers[MPOWER_RUNE2] = 1023;
    ch->pcdata->powers[MPOWER_RUNE3] = 15;
    send_to_char("You are now a blue mage!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "green mage"     ) )
    {
    ch->class = 2;
    if ( ch->trust > 6 )
    {
    ch->trust = ch->trust;
    ch->level = ch->level;
    }
    else
    {
    ch->trust = 6;
    ch->level = 6;
    }
    ch->pcdata->powers[MPOWER_RUNE0] = 3;
    ch->pcdata->powers[MPOWER_RUNE1] = 2047;
    ch->pcdata->powers[MPOWER_RUNE2] = 1023;
    ch->pcdata->powers[MPOWER_RUNE3] = 15;
    send_to_char("You are now a green mage!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "werewolf"   ) ) 
    {
    ch->class = 4;
   if (!IS_IMMORTAL(ch) )
    ch->level = 3;
    send_to_char("You are now a werewolf!\n\r", ch);
    }
/*
else if ( !str_cmp( arg2, "abomination" ))
{
ch->class = 3;
if (!IS_IMMORTAL(ch) )
    ch->level = 3;
    send_to_char("You are now an abomination!\n\r", ch);
    }
*/  
  else if ( !str_cmp( arg2, "vampire"    ) ) 
    {
    ch->class = 8;
   if (!IS_IMMORTAL(ch) )
    ch->level = 3;
    send_to_char("You are now a vampire!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "highlander" ) ) 
    {
    ch->class = 16;
   if (!IS_IMMORTAL(ch) )
    ch->level = 3;
    send_to_char("You are now a highlander!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "ninja"      ) ) 
    {
     ch->class = 128;
    if ( ch->trust > 6 )
     {
       ch->trust = ch->trust;
       ch->level = ch->level;
     }
     else
     {  
     ch->trust = 6;
     ch->level = 6;
     }
     send_to_char("You are now a ninja!\n\r", ch);
    }    
    else if ( !str_cmp( arg2, "monk"      ) )
    {
     ch->class = 512;
    if ( ch->trust > 6 )
     {
       ch->trust = ch->trust;
       ch->level = ch->level;
     }
     else
     {  
     ch->trust = 6;
     ch->level = 6;
     }
     send_to_char("You are now a monk!\n\r", ch);
    }
    else if ( !str_cmp( arg2, "drow"       ) ) 
    {
    ch->class = 32;
    if (!IS_IMMORTAL(ch) )
    ch->level = 3;
    send_to_char("You are now a drow!\n\r", ch);
    }
/*
    else if ( !str_cmp( arg2, "paladin"       ) )
    {
    ch->class = 256;
    send_to_char("You are now a paladin!\n\r", ch);
    }
*/
    else
    {
	send_to_char( "Syntax: class <char> <class>.\n\r", ch );
	send_to_char("      Classes:\n\r", ch );
    send_to_char("None, ", ch);
    send_to_char("Demon, ", ch);
    send_to_char("Demon Lord , ", ch);
    send_to_char("Purple Mage, Blue Mage, Yellow Mage, Green Mage, Red Mage, ", ch);
    send_to_char("Werewolf, ", ch);
    send_to_char("Vampire, ", ch);
    send_to_char("Ninja, ", ch);
    send_to_char("Monk, ", ch);
    send_to_char("Highlander, ", ch);
    send_to_char("Drow. ", ch);
	return;
    }
    send_to_char("Class Set.\n\r",ch);
    return;
}

void do_xptoken( CHAR_DATA *ch, char *argument )
{
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    char buf[MAX_STRING_LENGTH];
    OBJ_INDEX_DATA *pObjIndex;
    OBJ_DATA *obj;
    CHAR_DATA *victim;
    int value;

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );
 
    if ( IS_NPC(ch) || (ch->exp < 1 && !IS_JUDGE(ch)) )
    {
	send_to_char("You are unable to make a xp token.\n\r",ch);
	return;
    }
    else if ( arg1[0] == '\0' || !is_number( arg1 ) )
    {
	send_to_char("Please specify a value for the xp token.\n\r",ch);
	return;
    }
    else
    {
        value = atoi( arg1 );
	if ( value < 1 || value > 500000000 )
        {
	    send_to_char( "XP tokens should have a value between 1 and 500000000.\n\r", ch );
	    return;
        }
	else if ( value > ch->exp && !IS_JUDGE(ch) )
        {
	    sprintf(buf,"You only have %d xp points left to put into tokens.\n\r",ch->pcdata->quest);
	    send_to_char( buf, ch );
	    return;
        }
    }

    victim = get_char_room( ch, arg2 );

    if ( ( pObjIndex = get_obj_index( OBJ_VNUM_PROTOPLASM ) ) == NULL )
    {
	send_to_char( "Error...missing object, please inform Ackbar.\n\r", ch );
	return;
    }

    ch->exp -= value;
    if (ch->exp < 0) ch->exp = 0;
    obj = create_object( pObjIndex, value );
    obj->value[0] = value;
    obj->level = 1;
    obj->cost = value*1000;
    obj->item_type = ITEM_XPTOKEN;
    obj_to_char(obj,ch);
    if (obj->questmaker != NULL) free_string(obj->questmaker);
    obj->questmaker = str_dup(ch->name);
    free_string( obj->name );
    obj->name = str_dup( "xp token" );
    sprintf(buf,"a %d point xp token",value);
    free_string( obj->short_descr );
    obj->short_descr = str_dup( buf );
    sprintf(buf,"A %d point xp token lies on the floor.",value);
    free_string( obj->description );
    obj->description = str_dup( buf );
    if (victim != NULL && victim != ch)
    {
    	act( "You reach behind $N's ear and produce $p.", ch, obj, victim, TO_CHAR );
    	act( "$n reaches behind $N's ear and produces $p.", ch, obj, victim, TO_NOTVICT );
    	act( "$n reaches behind your ear and produces $p.", ch, obj, victim, TO_VICT );
    }
    else
    {
    	act( "You snap your fingers and reveal $p.", ch, obj, NULL, TO_CHAR );
    	act( "$n snaps $s fingers and reveals $p.", ch, obj, NULL, TO_ROOM );
    }
    return;
}

void do_status( CHAR_DATA *ch, char *argument ){
	
    DESCRIPTOR_DATA *d;
    char buf[MAX_INPUT_LENGTH];
    CHAR_DATA *och;
    
    send_to_char("#b[#wRank       #b] [#wName        #b] [#wKingdom         #b] [#wStatus #b] [#wClass         #b]\n\r", ch);
    for ( d = descriptor_list; d; d = d->next )
    {

	if ( d->connected == CON_PLAYING || d->connected == CON_EDITING )
	{
	    och = d->character;
	    sprintf(buf, "#b[#w%-14.14s #b] [#w%-11.11s #b] [#w%s #b] [#w%-6d #b] [#w%-17.17s #b]\n\r", convert_rank(och->race), och->name, format_color(char_kingdom(och), 12), och->race, sclass(och->class, och));
	    send_to_char(buf, ch);
	} 
    }
}

	    
	    
int strlen_color (char *argument)
{
    char  *str;
    int    i, length;

    str = argument;
    if (argument == NULL)
        return 0;

    for (length=i=0; i < strlen (argument); ++i)
    {
        if ((str [i] != '#') && (str [i] != '^'))
            ++length;
        if ((str [i] == '#') || (str [i] == '^'))
          {
            if ((str[i] == '#') && (str[i+1] == '#'))
                length=2+length;
            else if ((str[i] == '^') && (str[i+1] == '^'))
                length=2+length;
            else
                --length;
          }
    }

    return length;
}

char * format_color (char *argument, int len)
 {
   /*
    * this is a simple function that will format a string like
    * using number formats in the string but it will ignore 
    * colors.
   */
   
  char add_len[MAX_INPUT_LENGTH]; /* Following defines are for putting spaces into the rank */
  int sp1, sx;                    /* To fix the color problem. */
  sp1 = strlen_color(argument);   /* Finds the strlen_color of the argument */
  sprintf( add_len, " ");         /* Init. the add_len strength */

      for (sx=len; sx > sp1; sx--) /* 15 - 1 for add_len init.*/
            strcat( add_len, " "); /* For every time it will add a blank space after the rank */
  strcpy( finrank, argument); /* Adding spaces to finish out rank --Xerves*/
  strcat( finrank, add_len);  /* Adding the length to the end of the argument -- Xerves*/
  return finrank;
}