VERSION 5.00
Object = "{ECEDB943-AC41-11D2-AB20-000000000000}#2.0#0"; "cmax20.ocx"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmDoc 
   ClientHeight    =   2940
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4275
   Icon            =   "frmDoc.frx":0000
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   2940
   ScaleWidth      =   4275
   WindowState     =   2  'Maximized
   Begin CodeMaxCtl.CodeMax rt 
      Height          =   2415
      Left            =   150
      OleObjectBlob   =   "frmDoc.frx":030A
      TabIndex        =   0
      Top             =   90
      Width           =   3855
   End
   Begin ComctlLib.ImageList img 
      Left            =   1590
      Top             =   2610
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   14
      ImageHeight     =   13
      MaskColor       =   65280
      _Version        =   327682
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   3
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmDoc.frx":046C
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmDoc.frx":0566
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "frmDoc.frx":0660
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmDoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public TabNum As Long
Public Changed As Boolean
Public r As CodeMaxCtl.Range
Public FTP As Boolean

Private Sub Form_Load()
  On Error Resume Next
  rt.ImageList = img
    ' register a new 'DebugStepInto' command
    Dim g As New CodeMaxCtl.globals
    Call g.RegisterCommand(1000, "DebugStepInto", "Steps into the current function while debugging.")
    ' Map F8 to DebugStepInto
    Dim h As New CodeMaxCtl.HotKey
    h.VirtKey1 = Chr(&H77)  'F8
    Call g.RegisterHotKey(h, 1000)
    
    ' register a new 'DebugStepOver' command
    Call g.RegisterCommand(1001, "DebugStepOver", "Steps over the current function while debugging.")
    ' Map F10 to DebugStepOver
    h.VirtKey1 = Chr(&H79)  'F10
    Call g.RegisterHotKey(h, 1001)

    ' register a new 'DebugBreakpoint' command
    Call g.RegisterCommand(1002, "DebugBreakpoint", "Sets a breakpoint at the current line.")
    ' Map F9 to DebugBreakpoint
    h.VirtKey1 = Chr(&H78)  'F9
    Call g.RegisterHotKey(h, 1002)
  
  ReadOptions rt
  ReadInput
  If WhiteSpaced = True Then
    rt.DisplayWhitespace = True
  Else
    rt.DisplayWhitespace = False
  End If
    ' register a new 'DebugBreakpoint' command

End Sub

Private Sub Form_Resize()
  On Error Resume Next
  
  rt.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error Resume Next
  Dim zx As Integer, x As Integer
  Dim msgRes As VbMsgBoxResult
  If Changed = True Then
    msgRes = MsgBox("You have made changes to this document. Do you wish to save?", vbYesNoCancel + vbQuestion, "Save")
    If msgRes = vbYes Then
      doSave ActiveForm.Tag
    ElseIf msgRes = vbNo Then
      'do nothing
    ElseIf msgRes = vbCancel Then
      'Cancel
      Cancel = 1
      rt.SetFocus
    End If
  End If
  docCnt = docCnt - 1
  zx = Me.Tag
  Me.SetFocus
  For x = 1 To frmMain.tb.Tabs.Count
    If frmMain.tb.Tabs(x).Tag = Me.TabNum Then
      frmMain.tb.Tabs.Remove x
      Exit For
    End If
  Next
End Sub

Private Sub rt_Change(ByVal Control As CodeMaxCtl.ICodeMax)
  Changed = True
End Sub


Private Sub rt_GotFocus()
  Dim zx As Integer, x As Integer
  SetLang
  zx = Me.Tag
  For x = 1 To frmMain.tb.Tabs.Count
    If frmMain.tb.Tabs(x).Tag = Me.TabNum Then
      frmMain.tb.Tabs(x).Selected = True
      Exit For
    End If
  Next
End Sub

Private Function rt_MouseDown(ByVal Control As CodeMaxCtl.ICodeMax, ByVal Button As Long, ByVal Shift As Long, ByVal x As Long, ByVal Y As Long) As Boolean
  If Button = 2 Then PopupMenu frmMain.edit
End Function

Private Sub rt_RegisteredCmd(ByVal Control As CodeMaxCtl.ICodeMax, ByVal lCmd As CodeMaxCtl.cmCommand)
    Dim r As New CodeMaxCtl.Range
    Set r = Control.GetSel(False)
    
    If (lCmd = 1000) Then
        ' <DebugStepInto>
        'highlight the current line
        Control.HighlightedLine = r.EndLineNo
        ' <do whatever here>
    ElseIf lCmd = 1001 Then
        ' <DebugStepOver>
        ' highlight the current line
        Control.HighlightedLine = r.EndLineNo
        ' <do whatever here>
    ElseIf lCmd = 1002 Then
        ' <DebugBreakpoint>
        ' show the bookmark image in the left margin
        Dim lImages As Long
        Dim lTemp As Long
        lImages = Control.GetMarginImages(r.EndLineNo)
        lTemp = lImages And 2  '2 is the image bit in the imagelist
        If (lTemp <> 0) Then
            ' breakpoint is on -- turn it off
            lImages = lImages And Not (2)
        Else
            ' breakpoint is off -- turn it on
            lImages = lImages Or 2
        End If
                
        ' switch to the new image for the current line
        Call Control.SetMarginImages(r.EndLineNo, lImages)
    End If
End Sub

Private Sub rt_SelChange(ByVal Control As CodeMaxCtl.ICodeMax)
  On Error Resume Next
  Set r = rt.GetSel(True)
  frmMain.stBar.Panels(2).Text = "Row: " & r.StartLineNo + 1 & " Col: " & r.StartColNo + 1 & " Lines: " & rt.linecount
  If HighLight = True Then
    rt.HighlightedLine = r.EndLineNo
  Else
    rt.HighlightedLine = -1
  End If
End Sub

Private Function SetLang()
  Select Case LCase(rt.language)
    Case ""
      setChk 0
    Case "c/c++"
      setChk 1
    Case "basic"
      setChk 2
    Case "java"
      setChk 3
    Case "perl"
      setChk 4
    Case "pascal"
      setChk 5
    Case "sql"
      setChk 6
    Case "html"
      setChk 7
    Case "xml"
      setChk 8
    Case "css"
      setChk 9
  End Select
End Function

Private Function setChk(src As Integer)
  Dim x As Integer
  For x = 0 To 9
    frmMain.lang(x).Checked = False
  Next
  frmMain.lang(src).Checked = True
End Function
